# garage_administration_api_v0garage_v0_8_0

GarageAdministrationApiV0garageV080 - JavaScript client for garage_administration_api_v0garage_v0_8_0
Administrate your Garage cluster programatically, including status, layout, keys, buckets, and maintainance tasks.

*Disclaimer: The API is not stable yet, hence its v0 tag. The API can change at any time, and changes can include breaking backward compatibility. Read the changelog and upgrade your scripts before upgrading. Additionnaly, this specification is very early stage and can contain bugs, especially on error return codes/types that are not tested yet. Do not expect a well finished and polished product!*

This SDK is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v0.8.0
- Package version: v0.8.0
- Build package: org.openapitools.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/), please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install garage_administration_api_v0garage_v0_8_0 --save
```

Finally, you need to build the module:

```shell
npm run build
```

##### Local development

To use the library locally without publishing to a remote npm registry, first install the dependencies by changing into the directory containing `package.json` (and this README). Let's call this `JAVASCRIPT_CLIENT_DIR`. Then run:

```shell
npm install
```

Next, [link](https://docs.npmjs.com/cli/link) it globally in npm with the following, also from `JAVASCRIPT_CLIENT_DIR`:

```shell
npm link
```

To use the link you just defined in your project, switch to the directory you want to use your garage_administration_api_v0garage_v0_8_0 from, and run:

```shell
npm link /path/to/<JAVASCRIPT_CLIENT_DIR>
```

Finally, you need to build the module:

```shell
npm run build
```

#### git

If the library is hosted at a git repository, e.g.https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var GarageAdministrationApiV0garageV080 = require('garage_administration_api_v0garage_v0_8_0');

var defaultClient = GarageAdministrationApiV0garageV080.ApiClient.instance;
// Configure Bearer access token for authorization: bearerAuth
var bearerAuth = defaultClient.authentications['bearerAuth'];
bearerAuth.accessToken = "YOUR ACCESS TOKEN"

var api = new GarageAdministrationApiV0garageV080.BucketApi()
var allowBucketKeyRequest = new GarageAdministrationApiV0garageV080.AllowBucketKeyRequest(); // {AllowBucketKeyRequest} Aliases to put on the new bucket 
var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.allowBucketKey(allowBucketKeyRequest, callback);

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:3903/v0*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*GarageAdministrationApiV0garageV080.BucketApi* | [**allowBucketKey**](docs/BucketApi.md#allowBucketKey) | **POST** /bucket/allow | Allow key
*GarageAdministrationApiV0garageV080.BucketApi* | [**createBucket**](docs/BucketApi.md#createBucket) | **POST** /bucket | Create a bucket
*GarageAdministrationApiV0garageV080.BucketApi* | [**deleteBucket**](docs/BucketApi.md#deleteBucket) | **DELETE** /bucket?id&#x3D;{bucket_id} | Delete a bucket
*GarageAdministrationApiV0garageV080.BucketApi* | [**deleteBucketGlobalAlias**](docs/BucketApi.md#deleteBucketGlobalAlias) | **DELETE** /bucket/alias/global | Delete a global alias
*GarageAdministrationApiV0garageV080.BucketApi* | [**deleteBucketLocalAlias**](docs/BucketApi.md#deleteBucketLocalAlias) | **DELETE** /bucket/alias/local | Delete a local alias
*GarageAdministrationApiV0garageV080.BucketApi* | [**denyBucketKey**](docs/BucketApi.md#denyBucketKey) | **POST** /bucket/deny | Deny key
*GarageAdministrationApiV0garageV080.BucketApi* | [**findBucketInfo**](docs/BucketApi.md#findBucketInfo) | **GET** /bucket?globalAlias&#x3D;{alias} | Find a bucket
*GarageAdministrationApiV0garageV080.BucketApi* | [**getBucketInfo**](docs/BucketApi.md#getBucketInfo) | **GET** /bucket?id&#x3D;{bucket_id} | Get a bucket
*GarageAdministrationApiV0garageV080.BucketApi* | [**listBuckets**](docs/BucketApi.md#listBuckets) | **GET** /bucket | List all buckets
*GarageAdministrationApiV0garageV080.BucketApi* | [**putBucketGlobalAlias**](docs/BucketApi.md#putBucketGlobalAlias) | **PUT** /bucket/alias/global | Add a global alias
*GarageAdministrationApiV0garageV080.BucketApi* | [**putBucketLocalAlias**](docs/BucketApi.md#putBucketLocalAlias) | **PUT** /bucket/alias/local | Add a local alias
*GarageAdministrationApiV0garageV080.BucketApi* | [**updateBucket**](docs/BucketApi.md#updateBucket) | **PUT** /bucket?id&#x3D;{bucket_id} | Update a bucket
*GarageAdministrationApiV0garageV080.KeyApi* | [**addKey**](docs/KeyApi.md#addKey) | **POST** /key | Create a new API key
*GarageAdministrationApiV0garageV080.KeyApi* | [**deleteKey**](docs/KeyApi.md#deleteKey) | **DELETE** /key?id&#x3D;{access_key} | Delete a key
*GarageAdministrationApiV0garageV080.KeyApi* | [**getKey**](docs/KeyApi.md#getKey) | **GET** /key?id&#x3D;{access_key} | Get key information
*GarageAdministrationApiV0garageV080.KeyApi* | [**importKey**](docs/KeyApi.md#importKey) | **POST** /key/import | Import an existing key
*GarageAdministrationApiV0garageV080.KeyApi* | [**listKeys**](docs/KeyApi.md#listKeys) | **GET** /key | List all keys
*GarageAdministrationApiV0garageV080.KeyApi* | [**searchKey**](docs/KeyApi.md#searchKey) | **GET** /key?search&#x3D;{pattern} | Select key by pattern
*GarageAdministrationApiV0garageV080.KeyApi* | [**updateKey**](docs/KeyApi.md#updateKey) | **POST** /key?id&#x3D;{access_key} | Update a key
*GarageAdministrationApiV0garageV080.LayoutApi* | [**addLayout**](docs/LayoutApi.md#addLayout) | **POST** /layout | Send modifications to the cluster layout
*GarageAdministrationApiV0garageV080.LayoutApi* | [**applyLayout**](docs/LayoutApi.md#applyLayout) | **POST** /layout/apply | Apply staged layout
*GarageAdministrationApiV0garageV080.LayoutApi* | [**getLayout**](docs/LayoutApi.md#getLayout) | **GET** /layout | Details on the current and staged layout
*GarageAdministrationApiV0garageV080.LayoutApi* | [**revertLayout**](docs/LayoutApi.md#revertLayout) | **POST** /layout/revert | Clear staged layout
*GarageAdministrationApiV0garageV080.NodesApi* | [**addNode**](docs/NodesApi.md#addNode) | **POST** /connect | Connect target node to other Garage nodes
*GarageAdministrationApiV0garageV080.NodesApi* | [**getNodes**](docs/NodesApi.md#getNodes) | **GET** /status | Status of this node and other nodes in the cluster


## Documentation for Models

 - [GarageAdministrationApiV0garageV080.AddKeyRequest](docs/AddKeyRequest.md)
 - [GarageAdministrationApiV0garageV080.AddNode200ResponseInner](docs/AddNode200ResponseInner.md)
 - [GarageAdministrationApiV0garageV080.AllowBucketKeyRequest](docs/AllowBucketKeyRequest.md)
 - [GarageAdministrationApiV0garageV080.AllowBucketKeyRequestPermissions](docs/AllowBucketKeyRequestPermissions.md)
 - [GarageAdministrationApiV0garageV080.BucketInfo](docs/BucketInfo.md)
 - [GarageAdministrationApiV0garageV080.BucketInfoQuotas](docs/BucketInfoQuotas.md)
 - [GarageAdministrationApiV0garageV080.BucketInfoWebsiteConfig](docs/BucketInfoWebsiteConfig.md)
 - [GarageAdministrationApiV0garageV080.BucketKeyInfo](docs/BucketKeyInfo.md)
 - [GarageAdministrationApiV0garageV080.ClusterLayout](docs/ClusterLayout.md)
 - [GarageAdministrationApiV0garageV080.CreateBucketRequest](docs/CreateBucketRequest.md)
 - [GarageAdministrationApiV0garageV080.CreateBucketRequestLocalAlias](docs/CreateBucketRequestLocalAlias.md)
 - [GarageAdministrationApiV0garageV080.CreateBucketRequestLocalAliasAllow](docs/CreateBucketRequestLocalAliasAllow.md)
 - [GarageAdministrationApiV0garageV080.GetNodes200Response](docs/GetNodes200Response.md)
 - [GarageAdministrationApiV0garageV080.ImportKeyRequest](docs/ImportKeyRequest.md)
 - [GarageAdministrationApiV0garageV080.KeyInfo](docs/KeyInfo.md)
 - [GarageAdministrationApiV0garageV080.KeyInfoBucketsInner](docs/KeyInfoBucketsInner.md)
 - [GarageAdministrationApiV0garageV080.KeyInfoBucketsInnerPermissions](docs/KeyInfoBucketsInnerPermissions.md)
 - [GarageAdministrationApiV0garageV080.KeyInfoPermissions](docs/KeyInfoPermissions.md)
 - [GarageAdministrationApiV0garageV080.LayoutVersion](docs/LayoutVersion.md)
 - [GarageAdministrationApiV0garageV080.ListBuckets200ResponseInner](docs/ListBuckets200ResponseInner.md)
 - [GarageAdministrationApiV0garageV080.ListBuckets200ResponseInnerLocalAliasesInner](docs/ListBuckets200ResponseInnerLocalAliasesInner.md)
 - [GarageAdministrationApiV0garageV080.ListKeys200ResponseInner](docs/ListKeys200ResponseInner.md)
 - [GarageAdministrationApiV0garageV080.NodeClusterInfo](docs/NodeClusterInfo.md)
 - [GarageAdministrationApiV0garageV080.NodeNetworkInfo](docs/NodeNetworkInfo.md)
 - [GarageAdministrationApiV0garageV080.UpdateBucketRequest](docs/UpdateBucketRequest.md)
 - [GarageAdministrationApiV0garageV080.UpdateBucketRequestQuotas](docs/UpdateBucketRequestQuotas.md)
 - [GarageAdministrationApiV0garageV080.UpdateBucketRequestWebsiteAccess](docs/UpdateBucketRequestWebsiteAccess.md)
 - [GarageAdministrationApiV0garageV080.UpdateKeyRequest](docs/UpdateKeyRequest.md)
 - [GarageAdministrationApiV0garageV080.UpdateKeyRequestAllow](docs/UpdateKeyRequestAllow.md)
 - [GarageAdministrationApiV0garageV080.UpdateKeyRequestDeny](docs/UpdateKeyRequestDeny.md)


## Documentation for Authorization



### bearerAuth

- **Type**: Bearer authentication

